| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Member Functions | List of all members
Gaudi::Functional::Consumer< void(const In &...), Traits_ > Class Template Referenceabstract

`#include <GaudiAlg/Consumer.h>`

Inheritance diagram for Gaudi::Functional::Consumer< void(const In &...), Traits_ >:
[legend]
Collaboration diagram for Gaudi::Functional::Consumer< void(const In &...), Traits_ >:
[legend]

## Public Member Functions
StatusCode | execute () override final
virtual void | operator() (const In &...) const =0
Public Member Functions inherited from Gaudi::Functional::details::DataHandleMixin< void, std::tuple< In... >, Traits_ >
| DataHandleMixin (const std::string &name, ISvcLocator *pSvcLocator, const std::array< KeyValue, N_in > &inputs)
| DataHandleMixin (const std::string &name, ISvcLocator *locator, const KeyValue &input)
template<std::size_t N = 0>
const std::string & | inputLocation () const
unsigned int | inputLocationSize () const

## Private Member Functions
template<std::size_t... I>
StatusCode | invoke (std::index_sequence< I... >) const

## Additional Inherited Members
Public Types inherited from Gaudi::Functional::details::DataHandleMixin< void, std::tuple< In... >, Traits_ >
using | KeyValue = std::pair< std::string, std::string >
Static Public Attributes inherited from Gaudi::Functional::details::DataHandleMixin< void, std::tuple< In... >, Traits_ >
static constexpr std::size_t | N_in = sizeof...(In)
Protected Attributes inherited from Gaudi::Functional::details::DataHandleMixin< void, std::tuple< In... >, Traits_ >
std::tuple< details::InputHandle_t< Traits_, In >... > | m_inputs

## Detailed Description

### template<typename... In, typename Traits_>
class Gaudi::Functional::Consumer< void(const In &...), Traits_ >

Definition at line 13 of file Consumer.h.

## Member Function Documentation

template<typename... In, typename Traits_ >

StatusCode Gaudi::Functional::Consumer< void(const In &...), Traits_ >::execute | ( |  | ) |
| inline final override

Definition at line 19 of file Consumer.h.

20 { return invoke(std::index_sequence_for<In...>{}); }
Gaudi::Functional::Consumer< void(const In &...), Traits_ >::invoke
StatusCode invoke(std::index_sequence< I... >) const
Definition: Consumer.h:27
template<typename... In, typename Traits_ >
template<std::size_t... I>

StatusCode Gaudi::Functional::Consumer< void(const In &...), Traits_ >::invoke | ( | std::index_sequence< I... > |  | ) | const
| inline private

Definition at line 27 of file Consumer.h.

27 {
28 try {
29 (*this)( details::as_const(*std::get<I>(this->m_inputs).get())... );
30 } catch ( GaudiException& e ) {
31 ( e.code() ? this->warning() : this->error() )
32 << e.message() << endmsg;
33 return e.code();
34 }
35 return StatusCode::SUCCESS;
36 }
Gaudi::Functional::details::DataHandleMixin< void, std::tuple< In... >, Traits_ >::m_inputs
std::tuple< details::InputHandle_t< Traits_, In >... > m_inputs
Definition: FunctionalDetails.h:406
StatusCode::SUCCESS
Definition: StatusCode.h:30
Gaudi::Functional::details::as_const
constexpr std::add_const< T >::type & as_const(T &t) noexcept
Definition: FunctionalDetails.h:77
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:23
GaudiException::code
virtual const StatusCode & code() const
StatusCode for Exception.
Definition: GaudiException.h:127
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
template<typename... In, typename Traits_ >

virtual void Gaudi::Functional::Consumer< void(const In &...), Traits_ >::operator() | ( | const In & | ... | ) | const
| pure virtual

The documentation for this class was generated from the following file:

- GaudiAlg/GaudiAlg/Consumer.h